<#macro getPanelItem panelItem type>
    <#assign detail>
    name: '${panelItem.getName()}',
    type: '${type}',
    caption: '${panelItem.getCaption()}',
    <#if panelItem.getTitleBarCloseMode?? && panelItem.getTitleBarCloseMode()??>titleBarCloseMode: ${panelItem.getTitleBarCloseMode()},</#if>
    isShowCaption: <#if panelItem.isShowCaption?? && panelItem.isShowCaption()??>${panelItem.isShowCaption()?c}</#if>,
    sysCss: '<#if panelItem.getPSSysCss?? && panelItem.getPSSysCss()??>${panelItem.getPSSysCss().getCssName()}</#if>',
    itemType: '${panelItem.getItemType()}',
    itemStyle: '${panelItem.getItemStyle()}',
    <#if panelItem.getPSSysImage?? && panelItem.getPSSysImage()??>sysImage:{
    iconcls: '<#if panelItem.getPSSysImage().getCssClass?? && panelItem.getPSSysImage().getCssClass()??>${panelItem.getPSSysImage().getCssClass()}</#if>',
    imagePath:'<#if panelItem.getPSSysImage().getImagePath?? && panelItem.getPSSysImage().getImagePath()??>${panelItem.getPSSysImage().getImagePath()}</#if>',
    rawContent: '<#if panelItem.getPSSysImage().getRawContent?? && panelItem.getPSSysImage().getRawContent()??>${panelItem.getPSSysImage().getRawContent()}</#if>'
    },</#if> 
    visible: <#if panelItem.getPSPanelItemGroupLogic('PANELVISIBLE')??>false<#else>true</#if>,
    disabled: false,
    layout:'<#if panelItem.getPSLayout?? && panelItem.getPSLayout()?? && panelItem.getPSLayout().getLayout?? && panelItem.getPSLayout().getLayout()??>${panelItem.getPSLayout().getLayout()}</#if>',
    layoutPos:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getLayoutPos?? && panelItem.getPSLayoutPos().getLayoutPos()??>${panelItem.getPSLayoutPos().getLayoutPos()}</#if>',
    layoutHeight:<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getHeight?? && panelItem.getPSLayoutPos().getHeight()??>${panelItem.getPSLayoutPos().getHeight()}<#else>0</#if>,
    heightMode:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getHeightMode?? && panelItem.getPSLayoutPos().getHeightMode()??>${panelItem.getPSLayoutPos().getHeightMode()}</#if>',
    layoutWidth:<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getWidth?? && panelItem.getPSLayoutPos().getWidth()??>${panelItem.getPSLayoutPos().getWidth()}<#else>0</#if>,
    widthMode:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getWidthMode?? && panelItem.getPSLayoutPos().getWidthMode()??>${panelItem.getPSLayoutPos().getWidthMode()}</#if>',
    spacingBottom:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getSpacingBottom?? && panelItem.getPSLayoutPos().getSpacingBottom()??>${panelItem.getPSLayoutPos().getSpacingBottom()}</#if>',
    spacingLeft:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getSpacingLeft?? && panelItem.getPSLayoutPos().getSpacingLeft()??>${panelItem.getPSLayoutPos().getSpacingLeft()}</#if>',
    spacingRight:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getSpacingRight?? && panelItem.getPSLayoutPos().getSpacingRight()??>${panelItem.getPSLayoutPos().getSpacingRight()}</#if>',
    spacingTop:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getSpacingTop?? && panelItem.getPSLayoutPos().getSpacingTop()??>${panelItem.getPSLayoutPos().getSpacingTop()}</#if>',
    hAlignSelf:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getHAlignSelf?? && panelItem.getPSLayoutPos().getHAlignSelf()??>${panelItem.getPSLayoutPos().getHAlignSelf()}</#if>',
    vAlignSelf:'<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getVAlignSelf?? && panelItem.getPSLayoutPos().getVAlignSelf()??>${panelItem.getPSLayoutPos().getVAlignSelf()}</#if>',
    flexGrow:<#if panelItem.getPSLayoutPos?? && panelItem.getPSLayoutPos()?? && panelItem.getPSLayoutPos().getGrow?? && panelItem.getPSLayoutPos().getGrow()??>${panelItem.getPSLayoutPos().getGrow()}<#else>0</#if>,
    flexParams:{align:'<#if panelItem.getFlexAlign?? && panelItem.getFlexAlign()??>${panelItem.getFlexAlign()}</#if>',dir:'<#if panelItem.getFlexDir?? && panelItem.getFlexDir()??>${panelItem.getFlexDir()}</#if>',vAlign:'<#if panelItem.getFlexVAlign?? && panelItem.getFlexVAlign()??>${panelItem.getFlexVAlign()}</#if>'},
    <#if panelItem.getParentPSPanelItem?? && panelItem.getParentPSPanelItem()??>
    parentName: '${panelItem.getParentPSPanelItem().getName()}',
    </#if>
    panel: this
    </#assign>
    <#if panelItem.getItemType()  == 'CONTAINER'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}
    <#if panelItem.getPSPanelItems()??>, 
    details:[<#list panelItem.getPSPanelItems() as childPanelItem>'${childPanelItem.getName()}'<#if childPanelItem_has_next>,</#if></#list>]
    </#if>
    <#if panelItem.getDataRegionType()??>,
    dataRegionType: '${panelItem.getDataRegionType()}'
    </#if>
    <#if panelItem.getDataSourceType()??>,
    dataSourceType: '${panelItem.getDataSourceType()}'
    </#if>
    <#if panelItem.getPSAppDataEntity?? && panelItem.getPSAppDataEntity()??>,
    appDataEntityCodeName: '${panelItem.getPSAppDataEntity().getCodeName()?lower_case}'
    </#if>
    <#if panelItem.getPSAppDEMethod?? && panelItem.getPSAppDEMethod()??>,
    appDEMethodCodeName: '${panelItem.getPSAppDEMethod().getCodeName()}'
    </#if>
    }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'RAWITEM'>
    <#assign rawItem>
    viewType: '${view.getViewType()}',
    predefinedType: '${panelItem.getPSRawItem().getPredefinedType()}',
    contentType: '${panelItem.getPSRawItem().getContentType()}',
    contentStyle: '${panelItem.getPSRawItem().getCssStyle()}',
    rawContent: '<#if panelItem.getRawContent?? && panelItem.getRawContent()??>${panelItem.getRawContent()}</#if>',
    htmlContent: '<#if panelItem.getHtmlContent?? && panelItem.getHtmlContent()??>${panelItem.getHtmlContent()}</#if>',
    <#if panelItem.getPSRawItem().getRenderMode?? && panelItem.getPSRawItem().getRenderMode()??>
    renderMode: '${panelItem.getPSRawItem().getRenderMode()}',
    </#if>
    <#if panelItem.getPSRawItem()?? && panelItem.getPSRawItem().getWrapMode?? && panelItem.getPSRawItem().getWrapMode()??>
    wrapMode:'${panelItem.getPSRawItem().getWrapMode()}',
    </#if>
    <#if panelItem.getPSRawItem()?? && panelItem.getPSRawItem().getVAlign?? && panelItem.getPSRawItem().getVAlign()??>
    vAlign:'${panelItem.getPSRawItem().getVAlign()}',
    </#if>
    <#if panelItem.getPSRawItem()?? && panelItem.getPSRawItem().getHAlign?? && panelItem.getPSRawItem().getHAlign()??>
    hAlign:'${panelItem.getPSRawItem().getHAlign()}',
    </#if>
    </#assign>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}, ${rawItem} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'FIELD'>
    <#assign field>
    <#if panelItem.getFieldStates?? && panelItem.getFieldStates()??>
    fieldState: '${panelItem.getFieldStates()}',
    </#if>
    <#if panelItem.getPSEditor?? && panelItem.getPSEditor()??>
    <#if panelItem.getPSEditor().getPredefinedType?? && panelItem.getPSEditor().getPredefinedType()??>
    predefinedType: '${panelItem.getPSEditor().getPredefinedType()}',
    </#if>
    <#if panelItem.getPSEditor().getRenderMode?? && panelItem.getPSEditor().getRenderMode()??>
    renderMode: '${panelItem.getPSEditor().getRenderMode()}',
    </#if>
    </#if>
    <#if panelItem.getViewFieldName?? && panelItem.getViewFieldName()??>
    dataItemName:'${panelItem.getViewFieldName()}',
    </#if>
    <#if panelItem.getEditorType?? && panelItem.getEditorType()?? && (panelItem.getEditorType() == "SPAN")>
    <#if panelItem.getPSEditor?? && panelItem.getPSEditor()??>
    <#assign panelEditor = panelItem.getPSEditor() />
    <#if panelEditor.getWrapMode?? && panelEditor.getWrapMode()??>
    wrapMode:'${panelEditor.getWrapMode()}',
    </#if>
    <#if panelEditor.getVAlign?? && panelEditor.getVAlign()??>
    vAlign:'${panelEditor.getVAlign()}',
    </#if>
    <#if panelEditor.getHAlign?? && panelEditor.getHAlign()??>
    hAlign:'${panelEditor.getHAlign()}',
    </#if>
    </#if>
    </#if>
    </#assign>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}, ${field} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'CONTROL'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'BUTTON'>
    <#assign button>
    <#if panelItem.getButtonStyle?? && panelItem.getButtonStyle()??>
    buttonStyle: '${panelItem.getButtonStyle()}',
    </#if>
    <#if panelItem.getBorderStyle?? && panelItem.getBorderStyle()??>
    borderStyle: '${panelItem.getBorderStyle()}',
    </#if>
    iconAlign: '${panelItem.getIconAlign()}',
    <#if panelItem.getPSUIAction?? && panelItem.getPSUIAction()??>
    <#if panelItem.getPSUIAction().getPredefinedType?? && panelItem.getPSUIAction().getPredefinedType()??>
    predefinedType: '${panelItem.getPSUIAction().getPredefinedType()}',
    </#if>
    </#if>
    <#if panelItem.getRenderMode?? && panelItem.getRenderMode()??>
    renderMode: '${panelItem.getRenderMode()}',
    </#if>
    </#assign>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}, ${button} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'USERCONTROL'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'TABPANEL'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}<#if panelItem.getPSPanelTabPages()??>, 
    details:[<#list panelItem.getPSPanelTabPages() as tabpage>'${tabpage.getName()}'<#if tabpage_has_next>,</#if></#list>]</#if> }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'CTRLPOS'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail} }<#if panelItem_has_next>,</#if></@compress>
    <#elseif panelItem.getItemType()  == 'TABPAGE'>
    <@compress  single_line=true>${panelItem.name}:{ ${detail}<#if panelItem.getPSPanelItems()??>, 
    details:[<#list panelItem.getPSPanelItems() as childPanelItem>'${childPanelItem.getName()}'<#if childPanelItem_has_next>,</#if></#list>]</#if>}<#if panelItem_has_next>,</#if></@compress>
    </#if>
</#macro>
